'use strict';

const RSVP = require('rsvp');

module.exports = {
  description: 'Blueprint for @choiceform/ui-foundation',

  normalizeEntityName(entityName) {
    return entityName;
  },

  afterInstall: function(options) {
    const isAddon = options.project.isEmberCLIAddon();
    const targetName = isAddon ? 'addon' : 'app';

    this.ui.writeInfoLine(`Installing dependencies for ${targetName} ...`);
    this.ui.writeInfoLine(`正在为 ${targetName} 安装依赖...`);

    const blueprintOptions = { save: isAddon };
    return RSVP.all(
      [
        { name: 'ember-auto-import', blueprintOptions },
        { name: 'ember-cli-autoprefixer', blueprintOptions },
        { name: 'ember-css-modules', blueprintOptions },
        { name: 'ember-concurrency', blueprintOptions },
        { name: 'ember-concurrency-decorators', blueprintOptions },
        { name: 'ember-decorators', blueprintOptions },
        { name: 'ember-lifeline', blueprintOptions },
        { name: '@ember/optional-features' },
        { name: 'ember-cli-template-lint' },
        { name: 'ember-qunit-decorators' },
        { name: 'eslint-plugin-node' },
        { name: 'eslint-plugin-qunit' },
      ].map(this.addAddonToProject)
    ).then(() => {
      this.ui.writeLine(`For ${targetName} usage, please run:`);
      this.ui.writeLine(`用于 ${targetName}，请运行：`);
      this.ui.writeInfoLine(`ember generate foundation-for-${targetName}`);
    });
  },
};
